Subject: drivers/net/tlan question

From: Gabriel C <[email-masked]>
Date: Wed, 31 Oct 2007 18:59:02 +0100

Hi,

I noticed on current git the following warning with !CONFIG_PCI :

...

drivers/net/tlan.c: In function 'TLan_probe1':
drivers/net/tlan.c:682: warning: label 'err_out' defined but not used

...

I thought a simply #ifdef is missing but looking at TLan_probe1() I got confused about err_out_regions

...

#ifdef CONFIG_PCI
        if (pdev) {
                rc = pci_enable_device(pdev);
                if (rc)
                        return rc;

                rc = pci_request_regions(pdev, TLanSignature);
                if (rc) {
                        printk(KERN_ERR "TLAN: Could not reserve IO regions\n");
                        goto err_out;
                }
        }
#endif  /*  CONFIG_PCI  */

        dev = alloc_etherdev(sizeof(TLanPrivateInfo));
        if (dev == NULL) {
                printk(KERN_ERR "TLAN: Could not allocate memory for device.\n");
                rc = -ENOMEM;
                goto err_out_regions;
        }

...

...

err_out_regions:
#ifdef CONFIG_PCI
        if (pdev)
                pci_release_regions(pdev);
#endif
err_out:
        if (pdev)
                pci_disable_device(pdev);
        return rc;

...

It is possible 'dev' to be NULL with !CONFIG_PCI ? If is true then err_out_regions: does nothing ? 

Does this look right ?

Regards,

Gabriel